//
//  Stream.m
//  Reload
//
//  Created by georg on 07/04/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Stream.h"
#import <sys/time.h>

@implementation Stream

- (id)init {
	
	reloadImageView = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 480, 320)];
	data = [[NSMutableData alloc] initWithCapacity:20000];
	
	// get the initial time is second, use to get the time since application start
	struct timeval tv;
	gettimeofday(&tv, NULL);
	diff = tv.tv_sec;
	
	return self;
}



- (UIImageView*)streamImageView {
	return reloadImageView;
}



- (void)start {
	streaming = YES;
	[self downloadImage];
}



- (void)stop {
	streaming = NO;
}



- (void)downloadImage {
	
	startTimestamp = [self currentTime];
	
	// path to your local image
	NSString *address = @"http://192.168.20.117/live/live.jpg";
	
	NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:address]];
	[NSURLConnection connectionWithRequest:request delegate:self];
}



- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	//NSLog(@"error");
	downloadErrors++;
	[self downloadImage];
}



- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	[data setLength:0];												// reset download array
}



- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)partialData {
	[data appendData: partialData];
}



- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	
	float difference = (([self currentTime] - startTimestamp) - 0.040);
	
	// statistics
	if (++statCounter > 100) {		// report every X downloads...
		[self statistics];
		statCounter = 0;
	}
	
	if ([data length] > 0) {
		// check if data has content (displaying an empty data images shows nothing, but flashes the background)
		reloadImageView.image = [UIImage imageWithData:data];
		imagesDownloaded++;
		totalBytes += [data length];
	} else {
		zeroBytes++;
	}
	
	
	if (difference < 0) {
		// delay method call, if streaming is too fast
		[self performSelector:@selector(downloadImage) withObject:nil afterDelay:fabs(difference)];
		//NSLog(@"difference < 0, performSelector, %f", fabs(difference) );

	} else {
		// otherwise loop
		if (streaming) [self downloadImage];   // for start/stop
	}
	
	
}



- (float)currentTime {
	struct timeval tv;
	gettimeofday(&tv, NULL);
	float msec = tv.tv_usec / 1000000.0;
	float current = (tv.tv_sec - diff) + msec;
	return current;
}


// print statistics
- (void)statistics {
	imagesDownloaded = 1; // to prevent div by zero in testing
	NSLog(@"%.3f sec, %i images , totalBytes %i, zero: %i, errors: %i", startTimestamp, imagesDownloaded, totalBytes, zeroBytes, downloadErrors);
	NSLog(@"average/sec: %.2f KB, imagerate:%.1f, zero:%.1f, errors:%.1f", totalBytes/startTimestamp/1024, imagesDownloaded/startTimestamp, zeroBytes/startTimestamp, downloadErrors/startTimestamp);
	NSLog(@"average Images Size: %.2f KB", totalBytes/imagesDownloaded/1024.0 );
	NSLog(@"zero Images: %.2f%%", zeroBytes*100.0/imagesDownloaded);
}





@end
